//+---------------------------------------------------------------------------------+
//|                                                                _12.mq4 |
//|                                     Copyright  2007, MetaQuotes Software Corp. |
//|                                                       http://www.metaquotes.net |
//+---------------------------------------------------------------------------------+
//|                               _12.mq4                Malish8Levels.mq4 |
//|                           Aleksandr Pak, Almaty ekr-ap@mail.ru                  |
//|      http://forum.mql4.com/c/forum/2008/05/Percent_Levelsl2.mq4 |
//|        http://forum.mql4.com/ru/12190/page3    .
//|
//|        StartML,    
//|  ""    ,     .
//|     , .
//|      ,   ,  
//|    "",   "  ".
//| P.S.      ,  ,   , 
//|       ,  .   , .
//+-------------------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property indicator_chart_window 
extern int  = 1; //
 extern int  =0;
extern int control_level=12; //not great value = 12
extern bool Fibo=true, ray=false;  //false true
extern color  col_Fibo=DarkGray,col_up=Red,col_down=Blue;
extern double percent_lev1=0.5;
extern double percent_lev2=1.0;
extern double percent_lev3=1.5;
extern double percent_lev4=2;
extern double percent_lev5=2.5;
extern double percent_lev6=3;
extern double percent_lev7=3.5;
extern double percent_lev8=4;
extern double percent_lev9=4.5;
extern double percent_lev10=5;
extern double percent_lev11=5.5;
int contr_level;
double lev[12];
int init()
   {     contr_level=2*control_level;
      if(control_level>12) {control_level=12; contr_level=25;}
           for(int i=0;i<contr_level;i++) 
            {  
   ObjectCreate(StringConcatenate
   ("ML1",DoubleToStr(i,0)),OBJ_TREND,0,iTime(NULL,PERIOD_MN1,),Close[1],Time[1],Close[1]);         
   }  lev[1]=percent_lev1/100.* ;
      lev[2]=percent_lev2/100.* ;
      lev[3]=percent_lev3/100.* ;
      lev[4]=percent_lev4/100.* ;
      lev[5]=percent_lev5/100.* ;
      lev[6]=percent_lev6/100.* ;
      lev[7]=percent_lev7/100.* ;
      lev[8]=percent_lev8/100.* ;
      lev[9]=percent_lev9/100.* ;
      lev[10]=percent_lev10/100.* ;
      lev[11]=percent_lev11/100.* ;
      if(ObjectFind("StartML1")<0) 
      ObjectCreate("StartML1",OBJ_VLINE,0,iTime(NULL,PERIOD_MN1,),0); 
       // ObjectSet("StartML1", OBJPROP_COLOR, col_Fibo); 
         ObjectSet("StartML1",OBJPROP_STYLE,STYLE_DOT); //STYLE_DOT=2  
//+----  
     if(Fibo) if(ObjectFind("Fibo22")<0) 
      ObjectCreate("Fibo22",OBJ_FIBO,0,iTime(NULL,PERIOD_MN1,),Low[0],Time[0],Close[0]); 
      ObjectSet("Fibo22", OBJPROP_COLOR, col_Fibo);    
      ObjectSet("Fibo22",OBJPROP_RAY,0); 
     ObjectSet("Fibo22",OBJPROP_STYLE,STYLE_DOT); //STYLE_DOT=2 
  ObjectSet("Fibo22",OBJPROP_TIMEFRAMES,OBJ_PERIOD_M15|OBJ_PERIOD_M30|OBJ_PERIOD_H1|OBJ_PERIOD_H4|OBJ_PERIOD_D1); 
                  ObjectSet("Fibo22", OBJPROP_FIBOLEVELS, 8); 
                  ObjectSet("Fibo22", OBJPROP_FIRSTLEVEL+0, 0); 
                  ObjectSet("Fibo22", OBJPROP_FIRSTLEVEL+1, -0.25); 
                  ObjectSet("Fibo22", OBJPROP_FIRSTLEVEL+2, 0.382); 
                  ObjectSet("Fibo22", OBJPROP_FIRSTLEVEL+3, 0.618); 
                  ObjectSet("Fibo22", OBJPROP_FIRSTLEVEL+4, 1.0); 
                  ObjectSet("Fibo22", OBJPROP_FIRSTLEVEL+5, 0.5); 
                  ObjectSet("Fibo22", OBJPROP_FIRSTLEVEL+6, 0.75); 
                  ObjectSet("Fibo22", OBJPROP_FIRSTLEVEL+7, 0.25); 
                   ObjectSetFiboDescription("Fibo22",0,"%$"); 
                  ObjectSetFiboDescription("Fibo22",1,0); 
                  ObjectSetFiboDescription("Fibo22",2,"0.38"); 
                  ObjectSetFiboDescription("Fibo22",3,"0.62"); 
                  ObjectSetFiboDescription("Fibo22",4,"%$"); 
                  ObjectSetFiboDescription("Fibo22",5,"%$"); 
                  ObjectSetFiboDescription("Fibo22",6,"0.75"); 
                  ObjectSetFiboDescription("Fibo22",7,"0.25"); 
                  ObjectSet("Fibo22",OBJPROP_LEVELCOLOR,col_Fibo); 
                  ObjectSet("Fibo22",OBJPROP_LEVELSTYLE,STYLE_DOT); 
   return(0);
  }
int start()
  { 
   double   ts=ObjectGet("StartML1",OBJPROP_TIME1);
   double   t=ts-5*60*Period();
   double   t2=t+5*60*Period();
   int      b=iBarShift(NULL,0,ts ,FALSE);
   double  w, p;
   if(Low[b]<Close[0]) p=Low[b]; else p=High[b];
   for (int i=0; i<control_level+1;i++)
   {         string n= StringConcatenate ("ML1",DoubleToStr(i,0));               
            double pl=p+p*lev[i];
            ObjectSet(n,OBJPROP_RAY,ray);         
            ObjectSet(n,OBJPROP_COLOR,col_up); 
              ObjectSet(n,OBJPROP_STYLE,2);        
            ObjectSet(n,OBJPROP_TIME1,t);
            ObjectSet(n,OBJPROP_PRICE1,pl);
            ObjectSet(n,OBJPROP_TIME2,t2);
            ObjectSet(n,OBJPROP_PRICE2,pl);
            ObjectSetText(n,"+"+DoubleToStr(100*lev[i],1)+"%",7,"Arial");
            n= StringConcatenate ("ML1",DoubleToStr(i+control_level,0));
            pl=p-p*lev[i];
             ObjectSet(n,OBJPROP_RAY,ray);    
            ObjectSet(n,OBJPROP_COLOR,col_down);
             ObjectSet(n,OBJPROP_STYLE,2); 
            ObjectSet(n,OBJPROP_TIME1,t);
            ObjectSet(n,OBJPROP_PRICE1,pl);
            ObjectSet(n,OBJPROP_TIME2,t2);
            ObjectSet(n,OBJPROP_PRICE2,pl);
            ObjectSetText(n,"-"+DoubleToStr(100*lev[i],1)+"%",7,"Arial");
//+----          
        if(Low[b]>Close[0]) w=Low[iLowest(NULL,0,MODE_LOW,b,0)]; 
         else w=High[iHighest(NULL,0,MODE_HIGH,b,0)];  
  }  ObjectSet("Fibo22",OBJPROP_PRICE1,p); 
    ObjectSet("Fibo22",OBJPROP_TIME1,ts);
    ObjectSet("Fibo22",OBJPROP_PRICE2,w);
    ObjectSet("Fibo22",OBJPROP_TIME2,Time[0]);
//+----  
  } int deinit(){ 
  if (ObjectFind("Fibo22")!=-1) ObjectDelete("Fibo22"); 
   if (ObjectFind("StartML1")!=-1) ObjectDelete("StartML1"); 
   if (ObjectFind("ML11")!=-1) ObjectDelete("ML11"); 
   if (ObjectFind("ML12")!=-1) ObjectDelete("ML12"); 
   if (ObjectFind("ML13")!=-1) ObjectDelete("ML13");  
   if (ObjectFind("ML14")!=-1) ObjectDelete("ML14"); 
   if (ObjectFind("ML15")!=-1) ObjectDelete("ML15"); 
   if (ObjectFind("ML16")!=-1) ObjectDelete("ML16");
   if (ObjectFind("ML10")!=-1) ObjectDelete("ML10"); 
   if (ObjectFind("ML17")!=-1) ObjectDelete("ML17"); 
   if (ObjectFind("ML18")!=-1) ObjectDelete("ML18"); 
   if (ObjectFind("ML19")!=-1) ObjectDelete("ML19"); 
   if (ObjectFind("ML110")!=-1) ObjectDelete("ML110");
   if (ObjectFind("ML111")!=-1) ObjectDelete("ML111"); 
   if (ObjectFind("ML112")!=-1) ObjectDelete("ML112"); 
   if (ObjectFind("ML113")!=-1) ObjectDelete("ML113"); 
   if (ObjectFind("ML114")!=-1) ObjectDelete("ML114"); 
   if (ObjectFind("ML115")!=-1) ObjectDelete("ML115"); 
   if (ObjectFind("ML116")!=-1) ObjectDelete("ML116");
   if (ObjectFind("ML117")!=-1) ObjectDelete("ML117"); 
   if (ObjectFind("ML118")!=-1) ObjectDelete("ML118"); 
   if (ObjectFind("ML119")!=-1) ObjectDelete("ML119"); 
   if (ObjectFind("ML120")!=-1) ObjectDelete("ML120");
   if (ObjectFind("ML121")!=-1) ObjectDelete("ML121"); 
   if (ObjectFind("ML122")!=-1) ObjectDelete("ML122"); 
   if (ObjectFind("ML123")!=-1) ObjectDelete("ML123"); 
   if (ObjectFind("ML124")!=-1) ObjectDelete("ML124");
    WindowRedraw();
   return(0);
  }
//+-------------------------------------------------------------------------